unit UDsgnRDMLoader;

interface

uses SysUtils, Classes,SConnect,Dialogs;

type
  TDsgnRDMLoader = class(TComponent)
  private
    { Private declarations }
    FDataModuleName:string;
    FSiteName,
    FParentWorkFormName,
    FWorkFormName       :string;
    FConnector:TSocketConnection;
    procedure SetConnected(const Value: boolean);
    procedure SetFDataModuleName(const Value: string);
    function  GetConnected: boolean;
    procedure SetFConnector(const Value: TSocketConnection);
  protected
    { Protected declarations }
  public
    { Public declarations }
    Constructor Create(AOwner:TComponent); Override;
    Destructor  Destroy; Override;
    procedure   Notification(AComponent:TComponent;Opeartion:TOperation); Override;
  published
    { Published declarations }
    property Connector :TSocketConnection read FConnector write SetFConnector;
    property Connected :boolean read GetConnected  write SetConnected;
    property InSiteName:string  read FSiteName     write FSiteName;
    property InParentWorkFormName:string read  FParentWorkFormName
                                         write FParentWorkFormName;
    property InWorkFormName:string read FWorkFormName   write FWorkFormName;
    property DataModuleName:string read FDataModuleName write SetFDataModuleName;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Win32', [TDsgnRDMLoader]);
end;

//TDsgnRDMLoader
Constructor TDsgnRDMLoader.Create(AOwner: TComponent);
var str:string;
begin
  inherited Create(AOwner);
  self.FSiteName       := 'w]u@';
  self.FDataModuleName := '';
end;

Destructor TDsgnRDMLoader.Destroy;
begin
  if(self.FConnector <> nil)then
    self.FConnector := nil;
  inherited Destroy;
end;

function TDsgnRDMLoader.GetConnected: boolean;
begin
  result := FALSE;
  if(self.FConnector <> nil)then
    result := self.FConnector.Connected;
end;

procedure TDsgnRDMLoader.Notification(AComponent: TComponent;
  Opeartion: TOperation);
begin
  inherited Notification(AComponent,Opeartion);
  if(Opeartion = OpRemove)then
    if(self.FConnector <> nil)then
      if(self.FConnector = AComponent)then self.FConnector := nil;
end;

procedure TDsgnRDMLoader.SetConnected(const Value: boolean);
var TempModuleName:OleVariant;
begin
  if(csDesigning in self.ComponentState)then
    begin
      if(self.FConnector = nil)then Exit;
      if(self.FConnector.Connected =   Value)then Exit;
      if(trim(self.FSiteName)           = '')then Exit;
      if(trim(self.FWorkFormName)       = '')then Exit;
      if(trim(self.FParentWorkFormName) = '')then Exit;
      if(Value = TRUE)then
        begin//J
          self.FDataModuleName := '';
          self.FConnector.Connected := Value;
          if(self.FConnector.Connected = TRUE)then
            begin
              if(self.FConnector.AppServer
                     .Ap_LoadDMInDesignTime( self.FSiteName           //´W
                                            ,self.FParentWorkFormName //D@~W
                                            ,self.FWorkFormName       //@~W
                                            ,'DesignTimeRDMLoader'    //ϥΪ̦W
                                            ,'DesignTimeRDMLoader'    //ϥΪ̱KX
                                            ,'DesignTimeRDMLoader'    //@~vX
                                            ,TempModuleName //Ǧ^:JDataModuleW
                                            ) = TRUE)then
                self.FDataModuleName := TempModuleName;
              //Debug!! ShowMessage('DataModuleW : '+self.FDataModuleName);
            end;//if...end!!
        end//if...end!!
      else
        begin//
          if(self.FConnector.AppServer
                 .Ap_UnLoadDMInDesignTime(
                                   self.FSiteName           //´W
                                   ,self.FParentWorkFormName//D@~W
                                   ,self.FWorkFormName      //@~W
                                   ,'DesignTimeRDMLoader'   //ϥΪ̦W
                                   ,'DesignTimeRDMLoader'   //ϥΪ̱KX
                                   ,self.FDataModuleName    //nDataModuleW
                                   ,'DesignTimeRDMLoader'   //@~vX
                                   )=TRUE)then
            begin
              self.FConnector.Connected := Value;
              self.FDataModuleName      := '';
            end;//if...end!!
        end;//else...end!!
    end;//if...end!!
end;

procedure TDsgnRDMLoader.SetFConnector(const Value: TSocketConnection);
begin
  self.FConnector := Value;
  if(Value <> nil)then
    begin
      self.FConnector.Name       := 'TEST_Connection';
      self.FConnector.Address    := '127.0.0.1';
      self.FConnector.ServerGUID := '{97A21C1E-C262-4486-ACDB-EF2CD56161E7}';
      self.FConnector.ServerName := 'BDEAppSrvr.BDEAppSrvRDM';
      self.FConnector.Port       := 211;
    end;//if...end!!
end;

procedure TDsgnRDMLoader.SetFDataModuleName(const Value: string);
begin
  //
end;

end.
